
#property copyright "Afterburner 2011"
#property link      "http://www.forex-meta.com"

//
//
//
//
//

extern bool   EcnBroker       = true;
extern string SymbolsPrefix   = "";
extern string SymbolsSuffix   = "";
extern bool   UseAutoMagic    = true;
extern int    ManualMagic     = 1010100;  
extern bool   SignalMail      = false;
extern bool   EachTickMode    = false;
extern double Lots            = 1.0;
extern int    Slippage        = 3;
extern bool   UseStopLoss     = True;
extern int    StopLoss        = 200;
extern bool   UseTakeProfit   = False;
extern int    TakeProfit      = 10;
extern bool   UseTrailingStop = True;
extern int    TrailingStop    = 10;

//
//
//
//
//

#define SIGNAL_NONE 0
#define SIGNAL_BUY  1
#define SIGNAL_SELL 2
#define SIGNAL_CLOSEBUY  3
#define SIGNAL_CLOSESELL 4

//
//
//
//
//

int    BarCount;
int    Current;
int    digit = 0;
int    MagicNumber;

bool   TickCheck = False;

string s_symbol;

double PointRatio = 1;
double _Point;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init() 
{
   BarCount = Bars;
   
   if (EachTickMode) Current = 0; 
                else Current = 1;
                
   s_symbol = Symbol();
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic; 
              
              
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start() 
{
   double StopLossLevel, TakeProfitLevel;
   
   //
   //
   //
   //
   //
   
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==3 || digit==5) 
         PointRatio = 10;
   else  PointRatio = 1; 
   _Point  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;  
   
   //
   //
   //
   //
   //
   
   if (EachTickMode && Bars != BarCount) TickCheck = False;
   int Total = OrdersTotal();

   //+------------------------------------------------------------------+
   //| Signal Begin                                                     |
   //+------------------------------------------------------------------+
   //
   //
      int    Order   = SIGNAL_NONE;
      double Buy1_1  = iClose(s_symbol,0,Current);
      double Buy1_2  = iClose(s_symbol,0,Current+1);

      double Sell1_1 = iClose(s_symbol,0,Current);
      double Sell1_2 = iClose(s_symbol,0,Current+1);

   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+
   //
   //Check 
   
   bool IsTrade = False;
   for (int i = 0; i < Total; i ++) 
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL &&  OrderSymbol() == s_symbol) 
      {
         IsTrade = True;
         if (OrderType() == OP_BUY) 
         {
           if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
           {
              OrderClose(OrderTicket(), OrderLots(), Bid, Slippage*_Point, MediumSeaGreen);
              if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid,digit) + " Close Buy");
              if (!EachTickMode) BarCount = Bars;
                IsTrade = False;
                continue;
           }
           
           //Trailing stop
           //
           //
           //
           //
           
           if (UseTrailingStop && TrailingStop > 0) 
           {                 
             if (Bid - OrderOpenPrice() > _Point * TrailingStop) 
             {
               if (OrderStopLoss() < Bid - _Point * TrailingStop) 
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), Bid - _Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                  if (!EachTickMode) BarCount = Bars;
                     continue;
               }
             }
           }
         }
         
         //
         //
         //
         //
         //
          
         else 
         {
         
         //
         //
         //
         //
         //
         
         if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
         {
            OrderClose(OrderTicket(), OrderLots(), Ask, Slippage*_Point, DarkOrange);
            if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Ask,digit) + " Close Sell");
            if (!EachTickMode) BarCount = Bars;
              IsTrade = False;
              continue;
         }
         
         //Trailing stop
         //
         //
         //
         //
         
         if (UseTrailingStop && TrailingStop > 0) 
         {                 
           if ((OrderOpenPrice() - Ask) > (_Point * TrailingStop)) 
           {
             if ((OrderStopLoss() > (Ask + _Point * TrailingStop)) || (OrderStopLoss() == 0)) 
             {
                OrderModify(OrderTicket(),OrderOpenPrice(),Ask + _Point * TrailingStop,OrderTakeProfit(),0,DarkOrange);
                if (!EachTickMode) BarCount = Bars;
                  continue;
             }
           }
         }
       }
     }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+
   //
   //

   if (Buy1_1  > Buy1_2)  Order = SIGNAL_BUY;
   if (Sell1_1 < Sell1_2) Order = SIGNAL_SELL;


   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   //Buy
   //
   
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
   {
      if (!IsTrade) 
      {
      
       //
       //
       //
       //
       //
     
       if (AccountFreeMargin() < (100 * Lots)) {Print("We have no money. Free Margin = ", AccountFreeMargin());return(0);}
       
       //
       //
       //
       //
       //
       
       double BStopLossLevel;
       double BTakeProfitLevel;
       
       if (UseStopLoss)   BStopLossLevel = Ask - StopLoss * _Point; 
                     else BStopLossLevel = 0.0;
                     
       if (UseTakeProfit) BTakeProfitLevel = Ask + TakeProfit * _Point; 
                     else BTakeProfitLevel = 0.0;
       //
       //
       //
       //
       //
       
       if (!EcnBroker) 
       OrderSend(s_symbol,OP_BUY,Lots,NormalizeDouble(Ask,digit),Slippage*_Point,NormalizeDouble(BStopLossLevel,digit),  
                 NormalizeDouble(BTakeProfitLevel,digit),"Buy(#" + MagicNumber + ")",MagicNumber,0,DodgerBlue);
       else
       {
       int buyTicket    = OrderSend(s_symbol,OP_BUY,Lots,NormalizeDouble(Ask,digit),Slippage*_Point,0,0,"buy",MagicNumber,0,Blue);
       if  (buyTicket  >= 0)
       bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),NormalizeDouble(BStopLossLevel,digit),NormalizeDouble(BTakeProfitLevel,digit),0,CLR_NONE);
       if (OrderSelect(buyTicket, SELECT_BY_TICKET, MODE_TRADES)) 
       {
		    Print("BUY order opened : ", OrderOpenPrice());
          if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Ask,digit) + " Open Buy");
			 } 
			 else 
			 {
				Print("Error opening BUY order : ", GetLastError());
			 }
       }
       if (EachTickMode) TickCheck = True;
       if (!EachTickMode) BarCount = Bars;
       return(0);
      }
   }

   //Sell
   //
   //
   //
   //
   
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
   {
      if (!IsTrade) 
      {
      
       //
       //
       //
       //
       //
     
       if (AccountFreeMargin() < (100 * Lots)) {Print("We have no money. Free Margin = ", AccountFreeMargin());return(0);}
       
       //
       //
       //
       //
       //
       
       double SStopLossLevel;
       double STakeProfitLevel;
       
       if (UseStopLoss)   SStopLossLevel = Ask - StopLoss * _Point; 
                     else SStopLossLevel = 0.0;
                     
       if (UseTakeProfit) STakeProfitLevel = Ask + TakeProfit * _Point; 
                     else STakeProfitLevel = 0.0;
       //
       //
       //
       //
       //
       
       if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,Lots,NormalizeDouble(Bid,digit),Slippage*_Point,NormalizeDouble(SStopLossLevel,digit),  
                   NormalizeDouble(STakeProfitLevel,digit),"Sell(#" + MagicNumber + ")",MagicNumber,0,DeepPink);
           
       else
       {
		   int sellTicket    = OrderSend(s_symbol,OP_SELL,Lots,NormalizeDouble(Bid,digit),Slippage*_Point,0,0,"Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(sellTicket    >= 0) 
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),NormalizeDouble(SStopLossLevel,digit),NormalizeDouble(STakeProfitLevel,digit),0,CLR_NONE);
      
         if (OrderSelect(sellTicket, SELECT_BY_TICKET, MODE_TRADES)) 
         {
				Print("SELL order opened : ", OrderOpenPrice());
            if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Bid,digit) + " Open Sell");
			} 
			else 
			{
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(1933921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(1933922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(1933931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(1933932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(1933941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(1933942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(1933951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(1933961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(1933962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(1933963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(1933964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(1933965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(1933966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(1933967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(1933971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(1933972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(1933973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(1933981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(1933982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(1933983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(1933991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(1933992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(1933993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(1933994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(1933995);
   
return(ManualMagic);
}

